library CplTest;

uses
	WinProcs, WinTypes, SysUtils, Cpl;


procedure DoApplet(wndCpl: HWND; lParam1: longint; lParam2: longint);
begin
	MessageBox(wndCpl,'Hi from DoApplet()','Info',
			MB_OK or MB_ICONINFORMATION);
end; {DoApplet}


function CPlApplet(hwndCpl: HWND; uMsg: UINT; lParam1: longint;
		lParam2: longint): longint; stdcall; export;
var
	rv:		longint;
	pncpi:	LPNEWCPLINFO;
begin
	case uMsg of

		CPL_INIT: begin
			{Return non-zero (TRUE) for success, zero (FALSE) otherwise
			(e.g. required resource not available, etc.). May get called
			multiple times before the user chooses our applet(s).}
			rv:= 1;	{TRUE}
		end; {CPL_INIT}

		CPL_GETCOUNT: begin
			{return # of icons/dialogs supported by this applet}
			rv:= 1;	{"n"}
		end; {CPL_GETCOUNT}

		CPL_INQUIRE: begin
			{obsolete, return non-zero (TRUE) to signify not processed}
			rv:= 1;	{TRUE}
		end; {CPL_INQUIRE}

		CPL_NEWINQUIRE: begin
			{UINT uAppNum= (UINT)lParam1;			//=> 0..("n"-1)}
			pncpi:= LPNEWCPLINFO(lParam2);
			pncpi^.dwSize:= sizeof(NEWCPLINFO);
			pncpi^.dwFlags:= 0;
			pncpi^.dwHelpContext:= 0;
			pncpi^.lData:= 0;
			pncpi^.hIcon:= LoadIcon(0,IDI_APPLICATION);
			{NB: lstrcpyn() will *Always* NULL-terminate the buffer.}
			lstrcpyn(pncpi^.szName,'Applet caption',sizeof(pncpi^.szName));
			lstrcpyn(pncpi^.szInfo,'Applet hint',sizeof(pncpi^.szInfo));
			lstrcpyn(pncpi^.szHelpFile,''{gszHelpPath},sizeof(pncpi^.szHelpFile));
			rv:= 0;
		end; {CPL_NEWENQUIRE}

		CPL_DBLCLK: begin
			{the guts of the procedure}
			{UINT uAppNum= (UINT)lParam1;	//0..("n"-1)}
			{LONG lData= (LONG)lParam2;		//via CPL_NEWINQUIRE (could be a "this" ptr)}

			{... dialog runs here ...}
			DoApplet(hwndCpl,lParam1,lParam2);
			rv:= 0;	{success}
		end; {CPL_DBLCLK}

		CPL_STOP: begin
			{return zero for success}
			rv:= 0;
		end; {CPL_STOP}

		CPL_EXIT: begin
			{global cleanup, return zero for success}
			rv:= 0;
		end; {CPL_EXIT}

	else
		rv:= 0;
	end;
	Result:= rv;
end; {CplApplet}

exports
	CplApplet;

begin {MAIN}
end. {library CplTest}
