unit Joy10;

(* TJoy component v 0.0001
 * This component was fully wrote by Vanni Brutto
 *
 * you can modified it as you need, however
 * if you do it please report me yours changed
 *
 * asytnt@protec.it
 * http://www.geocities.com/SiliconValley/Lab/6806
 *)


interface

Uses Classes, MMSystem, Windows, Messages, Forms;

type
  TJoyMoveEvent = procedure(Sender: TObject; JoyButtons: Integer; JoyXPosition, JoyYPosition: Integer) of object;

  TJoy = class(TComponent)
  private
    FInterval: Cardinal;
    FWindowHandle: HWND;
    FOnJoyMove: TJoyMoveEvent;
    FJoyStick: Integer;
    FEnabled: Boolean;
    procedure UpdateTimer;
    procedure SetEnabled(Value: Boolean);
    procedure SetInterval(Value: Cardinal);
    procedure SetOnJoyMove(Value: TJoyMoveEvent);
    procedure WndProc(var Msg: TMessage);
  protected
    procedure JoyMoved(Buttons: Integer; JoyXPosition: Integer; JoyYPosition: Integer); dynamic;
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
  published
    property JoyStick: Integer read FJoyStick write FJoyStick default 0;
    property Enabled: Boolean read FEnabled write SetEnabled default True;
    property Interval: Cardinal read FInterval write SetInterval default 0;
    property OnJoyMove: TJoyMoveEvent read FOnJoyMove write SetOnJoyMove;
  end;

procedure Register;

implementation

constructor TJoy.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  FEnabled := True;
  FInterval:= 0;
  FWindowHandle := AllocateHWnd(WndProc);
end;

destructor TJoy.Destroy;
begin
  FEnabled := False;
  UpdateTimer;
  DeallocateHWnd(FWindowHandle);
  inherited Destroy;
end;

procedure TJoy.WndProc(var Msg: TMessage);
begin
  with Msg do
    Case Msg of
      MM_JOY1MOVE:
        begin
          try
            JoyMoved(wParam, LoWord(lParam), HiWord(lParam));
          except
            Application.HandleException(Self);
          end
        end;
      MM_JOY2MOVE:
        begin
          try
            JoyMoved(wParam, LoWord(lParam), HiWord(lParam));
          except
            Application.HandleException(Self);
          end
        end;
      else
        begin
          Result := DefWindowProc(FWindowHandle, Msg, wParam, lParam);
        end;
    end;
end;

procedure TJoy.UpdateTimer;
begin
  JoyReleaseCapture(FJoyStick);
  if FEnabled and Assigned(FOnJoyMove) then
    {if }JoySetCapture(FWindowHandle, FJoyStick, FInterval, false){ = 0 then
      raise EOutOfResources.Create(SNoTimers);}
end;

procedure TJoy.SetEnabled(Value: Boolean);
begin
  if Value <> FEnabled then
  begin
    FEnabled := Value;
    UpdateTimer;
  end;
end;

procedure TJoy.SetInterval(Value: Cardinal);
begin
  if Value <> FInterval then
  begin
    FInterval := Value;
    UpdateTimer;
  end;
end;

procedure TJoy.SetOnJoyMove(Value: TJoyMoveEvent);
begin
  FOnJoyMove := Value;
  UpdateTimer;
end;

procedure TJoy.JoyMoved(Buttons: Integer; JoyXPosition: Integer; JoyYPosition: Integer);
begin
  if Assigned(FOnJoyMove) then FOnJoyMove(Self, Buttons, JoyXPosition, JoyYPosition);
end;

//Occorre commentare?
procedure Register;
begin
  RegisterComponents('Standard', [TJoy]);
end;

end.
