unit Main;

interface

Uses
  About,
  Second,
  Windows,
  CommCtrl,
  ListBox,
  Messages;

procedure WinMain;

implementation

const
  AppName = 'WinVB';
  AppIco = 'AboutIco';
  mnuOpen = 1;
  mnuNew = 9;
  mnuNewWin = 2;
  mnuSaveAs = 3;
  mnuExit = 4;
  mnuCut = 5;
  mnuCopy = 6;
  mnuPaste = 7;
  mnuAbout = 8;
  btnCaption = 100;
  btnSend = 101;
  btnEditor = 102;
  sNewText = 'You can type here as you want';

var hwndStatusBar: hWnd;
    htxtEditor: hWnd;
    hPopUpMenu: hMenu;


    
procedure WmRButtonUp(var Window: hWnd; var Msg: TWmRButtonUp);
var Rect: TRect;
    iMenuHeight,
    iCaptionHeight,
    iBorderSize: Integer;
begin
  GetWindowRect(Window, Rect);

  iCaptionHeight := GetSystemMetrics(SM_CYCAPTION);
  iMenuHeight := GetSystemMetrics(SM_CYMENU);
  iBorderSize := GetSystemMetrics(SM_CXBORDER);

  Msg.XPos := Msg.XPos + Rect.Left + iBorderSize;
  Msg.YPos := Msg.YPos + Rect.Top + iCaptionHeight + iMenuHeight + iBorderSize;

  TrackPopUpMenu(hPopUpMenu, 2, Msg.xPos, Msg.yPos, 0, Window, nil);
end;

procedure WmCreate(var Window: hWnd; var Msg: TWmCreate);
begin
  hwndStatusBar := CreateStatusWindow(WS_CHILD or WS_VISIBLE or
                                      WS_CLIPSIBLINGS or CCS_BOTTOM
                                      or SBARS_SIZEGRIP,
                                      'This sample was made By Brutto Vanni',
                                      Window, 2);

  CreateWindowEx(0, 'button', 'Button', WS_CHILD or WS_VISIBLE or BS_PUSHBUTTON, 30, 30, 70, 70, Window, btnCaption, HInstance, nil);

  CreateWindowEx(0, 'button', 'Send', WS_CHILD or WS_VISIBLE or BS_PUSHBUTTON, 110, 30, 70, 70, Window, btnSend, HInstance, nil);

  CreateWindowEx(0, 'button', 'Editor', WS_CHILD or WS_VISIBLE or BS_PUSHBUTTON, 190, 30, 70, 70, Window, btnEditor, HInstance, nil);

  CreateWindowEx(0, 'static', 'right click the windows',
               WS_CHILD or WS_VISIBLE, 0, 0, 500, 30, Window, 0, HInstance, nil);

  htxtEditor := CreateWindowEx(WS_EX_CLIENTEDGE, 'edit', sNewText,
               WS_CHILD or WS_VISIBLE or WS_BORDER or ES_MULTILINE, 70, 100, 500, 800, Window, 0, HInstance, nil);
end;

procedure WmSize(var Window: hWnd; var Msg: TWmSize);
var Rect,
    statusRect: TRect;
    x,
    y,
    cx,
    cy: Integer;
begin
  if not isWindowVisible(htxtEditor) then Begin
    GetClientRect(Window, Rect);
    InvalidateRect(Window, @Rect, True);
  end;

  GetWindowRect(hwndStatusBar, Rect);
  cy := Rect.Bottom;
  x := 0;
  y := Msg.Height - cy;
  cx := Msg.Width;

  MoveWindow(hwndStatusBar, x, y, cx, cy, True);

  GetWindowRect(hwndStatusBar, statusRect);

  MoveWindow(htxtEditor, 0, 110, Msg.Width, Msg.Height -
            (statusRect.Bottom - statusRect.Top + 110), True);
end;

procedure WmPaint(var Window: hWnd; var Msg: TWmPaint);
var DC: hDC;
    ps: TPaintStruct;
    Rect: TRect;
begin
  DC := BeginPaint(Window, ps);

  SetBkMode(DC, TRANSPARENT);

  GetClientRect(Window, Rect);
  DrawText(DC, 'Hello, Windows 95!', -1, Rect, DT_SINGLELINE or
           DT_CENTER or DT_VCENTER);

  EndPaint(Window, ps);
end;

procedure WmCommand(var Window: hWnd; var Msg: TWmCommand);
  procedure ShowMessage(S: String);
    begin
      MessageBox(Window, PChar(S), AppName, 0);
    end;
begin
  Case Msg.ItemID Of
    mnuOpen :
      Begin
        DialogBox(hInstance, 'frmListSample', Window, TFnWndProc(@frmListSampleProc));
        SetForegroundWindow(Window);
      End;
    mnuNew : SendMessage(htxtEditor, WM_SETTEXT, 0, Integer(PChar(sNewText)));
    mnuNewWin : frmSecondShow;
    mnuSaveAs : ShowMessage('Save As');
    mnuCut : ShowMessage('Cut');
    mnuCopy : ShowMessage('Copy');
    mnuPaste : ShowMessage('Paste');
    mnuExit :
      begin
        SendMessage(Window, WM_CLOSE, 0, 0);
      end;
    mnuAbout :
      Begin
        DialogBox(hInstance, 'AboutBox', Window, TFnWndProc(@AboutDlgProc));
        SetForegroundWindow(Window);
      End;
    btnCaption:
      Begin
        SetWindowText(Window, 'Fully wrote by Brutto Vanni');
      End;
    btnSend:
      Begin
        SendMessage(htxtEditor, WM_SETTEXT, 0, Integer(PChar('And this is only a text' +
                                #13 + #10 + 'of the Win32 API programming...' + #13 + #10 +
                                'This program was fully made By Brutto Vanni!')));
      End;
    btnEditor:
      Begin
        if IsWindowVisible(htxtEditor) Then
          ShowWindow(htxtEditor, SW_HIDE)
        Else ShowWindow(htxtEditor, SW_NORMAL)
      End;
  end;
end;

function WindowProc(Window: HWnd; Message: Cardinal; WParam: Word;
                    LParam: Longint): LongInt; stdcall;
var wMsg: TMessage;
procedure ConvertMsg;
  begin
    wMsg.Msg := Message;
    wMsg.WParam := WParam;
    wMsg.LParam := LParam;
  end;
begin
  Case Message of
    WM_DESTROY :
      Begin
        DestroyWindow(hwndSecond);
        PostQuitMessage(0);
      End;
    WM_CREATE:
      Begin
        ConvertMsg;
        WmCreate(Window, TWmCreate(wMsg));
      End;
    WM_COMMAND:
      begin
        ConvertMsg;
        WmCommand(Window, TWmCommand(wMsg));
      end;
    WM_PAINT:
      Begin
        ConvertMsg;
        WmPaint(Window, TWmPaint(wMsg));
      End;
    WM_SIZE:
      Begin
        ConvertMsg;
        WmSize(Window, TWmSize(wMsg));
      End;
    WM_RBUTTONUP:
      Begin
        ConvertMsg;
        WmRButtonUp(Window, TWmRButtonUp(wMsg));
      End;
  end;
  Result:= DefWindowProc(Window, Message, WParam, LParam);
end;

procedure WinMain;
var
  Window: HWnd;
  MenuPopUp,
  Menu: hMenu;
  Message: TMsg;
const
  WindowClass: TWndClassEx = (
    style:         0;
    lpfnWndProc:   nil;
    cbClsExtra:    0;
    cbWndExtra:    0;
    hInstance:     0;
    hIcon:         0;
    hCursor:       0;
    hbrBackground: 0;
    lpszMenuName:  '';
    lpszClassName: AppName);

begin
  WindowClass.cbSize:= SizeOF(WindowClass);
  WindowClass.lpfnWndProc:= TFnWndProc(@WindowProc);

  if HPrevInst = 0 then begin
    WindowClass.hInstance:= HInstance;
    WindowClass.hIcon := LoadIcon(HInstance, AppIco);
    WindowClass.hCursor := LoadCursor(0, idc_Arrow);
    WindowClass.hbrBackground:= COLOR_WINDOW;

    if RegisterClassEx(WindowClass) = 0 then
      Halt(255);
  end;

  Menu := CreateMenu;  //Create the Window menu

  MenuPopUp := CreateMenu; //Create the File Menu

  AppendMenu(MenuPopUp, MF_STRING, mnuNewWin, 'Open a new Window');
  AppendMenu(MenuPopUp, MF_SEPARATOR, 0, '');
  AppendMenu(MenuPopUp, MF_STRING, mnuNew, '&New Edit Control');
  AppendMenu(MenuPopUp, MF_STRING, mnuOpen, '&Open the String Items Editor');
  AppendMenu(MenuPopUp, MF_SEPARATOR, 0, '');
  AppendMenu(MenuPopUp, MF_STRING, mnuSaveAs, 'Save &As');
  AppendMenu(MenuPopUp, MF_SEPARATOR, 0, '');
  AppendMenu(MenuPopUp, MF_STRING, mnuExit, '&Exit');

  AppendMenu(Menu, MF_POPUP, MenuPopUp, '&File'); //Add File Menu to Window menu


  MenuPopUp := CreateMenu; //Create Edit Menu

  AppendMenu(MenuPopUp, MF_STRING, mnuCut, '&Cut');
  AppendMenu(MenuPopUp, MF_STRING, mnuCopy, '&Copy');
  AppendMenu(MenuPopUp, MF_STRING, mnuPaste, '&Paste');

  AppendMenu(Menu, MF_POPUP, MenuPopUp, '&Edit'); //Add Edit Menu to Window Menu

  hPopUpMenu := MenuPopUp;


  MenuPopUp := CreateMenu; //Create Help Menu

  AppendMenu(MenuPopUp, MF_STRING, mnuAbout, '&About');

  AppendMenu(Menu, MF_POPUP, MenuPopUp, '&Help'); //Add Help Menu to Window Menu

  Window:= CreateWindowEx(0,
                          AppName,          {Class name}
                          'Object Pascal sample',      {Window name}
                          ws_OverlappedWindow,  {style}
                          cw_UseDefault,        {X}
                          cw_UseDefault,        {Y}
                          cw_UseDefault,        {Width}
                          cw_UseDefault,        {Height}
                          0,                    {WndParent}
                          Menu,                    {Menu}
                          HInstance,            {Instance}
                          nil);                 {structure creation parameter}

  If Window = 0 Then Halt;

  ShowWindow(Window, CmdShow);
  UpdateWindow(Window);

  while GetMessage(Message, 0, 0, 0) do
  begin
    {This translates virtual-key messages into character messages.}
    TranslateMessage(Message);
    DispatchMessage(Message); {The translated message is now 'mailed' out.}
  end;
  Halt(Message.wParam);
end; {WinMain}

{****************************}

end.
