(*
 *
 * TCanvas DEMO v1.0
 * Questo esempio  stato 
 *          -quasi- 
 * interamente sviluppato da
 * Brutto Vanni   asytnt@protec.it
 *
 * Questo progetto  parte integrante
 * del mio personalissimo corso Delphi
 * reperibile al seguente indirizzo:
 *
 * http://www.geocities.com/SiliconValley/Lab/6806
 *
 *
 * il progetto  assolutamente freeware e modificabile,
 * fammi comunque sapere cosa ne pensi del mio corso!
 *
 *
 * N.B. il file fondoblu potrebbe essere stato incluso
 * come risorsa compilata (.res), tuttavia per semplicit
 * di comprensione del corso ho preferito fornirlo come
 * bitmap esterno :)
 *)
 
unit MainForm;

interface

uses
  Windows,
  Graphics,
  Forms,
  Menus,
  Classes;

type
  TMain = class(TForm)
    MainMenu: TMainMenu;
    mnuPens: TMenuItem;
    mnuPenStyles: TMenuItem;
    mnuPenColors: TMenuItem;
    mnuBrush: TMenuItem;
    mnuBrush1: TMenuItem;
    mnuBrush2: TMenuItem;
    mnuMethods: TMenuItem;
    mnuTextOut: TMenuItem;
    mnuPoligon: TMenuItem;
    procedure mnuPenStylesClick(Sender: TObject);
    procedure mnuPenColorsClick(Sender: TObject);
    procedure mnuBrush1Click(Sender: TObject);
    procedure mnuBrush2Click(Sender: TObject);
    procedure mnuTextOutClick(Sender: TObject);
    procedure mnuPoligonClick(Sender: TObject);
  private
    { Private declarations }
    procedure ClearCanvas;
    procedure SetPenDefaults;
  public
    { Public declarations }
  end;

var
  Main: TMain;

implementation

{$R *.DFM}

procedure TMain.ClearCanvas;
begin
 { Pulisce il contenuto del Canvas }
 with Canvas do begin
   Brush.Style := bsSolid;
   Brush.Color := clWhite;
   FillRect(ClipRect);
 end;
end;

procedure TMain.SetPenDefaults;
begin
  with Canvas.Pen do begin
    Width := 1;       // Setta pen width a 1 pixel
    Mode := pmCopy;   // Setta pen mode a default mode
    Style := psSolid; // Setta pen style a default style
    Color := clBlack; // Setta pen color a default color
  end;
end;

procedure TMain.mnuPenStylesClick(Sender: TObject);
var
  yPos: integer;
  PenStyle: TPenStyle;
begin
  ClearCanvas;     // Pulisce il contenuto del canvas
  SetPenDefaults;

   YPos := 20;
   PenStyle:= psSolid;

   Canvas.TextOut(1, 10, ' psSolid ');
   Canvas.TextOut(1, 30, ' psDash ');
   Canvas.TextOut(1, 50, ' psDot ');
   Canvas.TextOut(1, 70, ' psDashDot ');
   Canvas.TextOut(1, 90, ' psDashDotDot ');
   Canvas.TextOut(1, 110, ' psClear ');
   Canvas.TextOut(1, 130, ' psInsideFrame ');

   while Ord(PenStyle) <= ord(psInsideFrame) do
   begin
     Canvas.Pen.Style := PenStyle;      // Setta Pen style
     Canvas.MoveTo(100, yPos);          // Setta drawing location
     Canvas.LineTo(ClientWidth, yPos);  // Disegna una linea line
     inc(yPos, 20);              // Incrementa yPos
     inc(PenStyle);  // Incrementa Penstyle ad un nuovo stile di penna
   end;
end;

procedure TMain.mnuPenColorsClick(Sender: TObject);
var
  i: integer;
begin
  ClearCanvas;    // Pulisce il canvas
  SetPenDefaults; // Setta le propriet di default
  with Canvas do begin
    for i := 1 to 100 do begin
      { disegna in modo casuale le linee }
      Pen.Color := RGB(Random(255),Random(255), Random(255));
      MoveTo(random(ClientWidth), Random(ClientHeight));
      LineTo(random(ClientWidth), Random(ClientHeight));
    end
  end;
end;

procedure TMain.mnuBrush1Click(Sender: TObject);
begin
  ClearCanvas; //Pulisce il canvas
  Canvas.Brush.Style := bsDiagCross; //Setta la propriet style a "reticolo"
  Canvas.Brush.Color := clRed; //Colore della penna = rosso
  Canvas.Ellipse(0, 0, ClientWidth, ClientHeight); //Disegna una elisse nella finestra
end;

procedure TMain.mnuBrush2Click(Sender: TObject);
var Bitmap: TBitmap;
begin
  Bitmap := TBitmap.Create; //Crea una bitmap
  Bitmap.LoadFromFile('fondoblu.bmp'); //Carica bitmap "fondoblu"
  Canvas.Brush.Bitmap := Bitmap; // Setta il brush a "fondoblu"
  Canvas.FillRect(Rect(0,0,clientwidth,clientheight)); //Riempi il form
  Canvas.Brush.Bitmap := nil; //Dealloca memoria del brush
  Bitmap.Free; //Libera memoria della bitmap
end;

procedure TMain.mnuTextOutClick(Sender: TObject);
begin
  Canvas.Brush.Style := bsClear; //Stile scrittura trasparente
  Canvas.TextOut(0, 0, 'Hello Delphi Programmers!'); //Scrive!
end;

procedure TMain.mnuPoligonClick(Sender: TObject);
begin
  Canvas.Brush.Style := bsSolid; //Poligono riempito
  Canvas.Brush.Color := clTeal; //Colore Teal
  Canvas.Polygon([
                   Point(10, 10),  //Primo punto del poligono
                   Point(30, 10),  //Secondo punto del poligono
                   Point(130, 30), //Terzo punto del poligono
                   Point(240, 120) //Quarto punto del poligono
                  ]);
end;

end.
