unit Second;

interface

Uses
  Windows,
  About,
  Messages;

var hwndSecond: hwnd = 0;

procedure frmSecondShow;




implementation

Const
  sfrmSecond = 'SecondWin';
  mnuAbout = 1;
  mnuExit = 2;

procedure WmCommand(var Window: hWnd; var Msg: TWmCommand);
begin
  Case Msg.ItemID Of
    mnuAbout :
      Begin
        DialogBox(hInstance, 'AboutBox', Window, TFnWndProc(@AboutDlgProc));
        SetForegroundWindow(Window);
      End;
    mnuExit :
      Begin
        SendMessage(Window, WM_CLOSE, 0, 0);
      End;
  end;
end;

function WindowProc(Window: HWnd; Message: Cardinal; WParam: Word;
                    LParam: Longint): LongInt; stdcall;
var wMsg: TMessage;
procedure ConvertMsg;
  begin
    wMsg.Msg := Message;
    wMsg.WParam := WParam;
    wMsg.LParam := LParam;
  end;
begin
  Case Message Of
    WM_COMMAND:
      Begin
        ConvertMsg;
        WmCommand(Window, TWmCommand(wMsg));
      End;
  End;
  Result:= DefWindowProc(Window, Message, WParam, LParam);
end;

procedure frmSecondShow;
const
  WindowClass: TWndClassEx = (
    style:         0;
    lpfnWndProc:   nil;
    cbClsExtra:    0;
    cbWndExtra:    0;
    hInstance:     0;
    hIcon:         0;
    hCursor:       0;
    hbrBackground: 0;
    lpszMenuName:  'MainMenu';
    lpszClassName: sfrmSecond);

begin
  WindowClass.cbSize:= SizeOF(WindowClass);
  WindowClass.lpfnWndProc:= TFnWndProc(@WindowProc);

  if HPrevInst = 0 then begin
    WindowClass.hInstance:= HInstance;
    WindowClass.hIcon := LoadIcon(0, IDI_APPLICATION);
    WindowClass.hCursor := LoadCursor(0, idc_Arrow);
    WindowClass.hbrBackground:= COLOR_WINDOW;
    RegisterClassEx(WindowClass);
  end;

  hwndSecond:= CreateWindowEx(0,
                          sfrmSecond,          {Class name}
                          'The Second Window', {Window name}
                          ws_OverlappedWindow,  {style}
                          cw_UseDefault,        {X}
                          cw_UseDefault,        {Y}
                          cw_UseDefault,        {Width}
                          cw_UseDefault,        {Height}
                          0,                    {WndParent}
                          0,                    {Menu}
                          HInstance,            {Instance}
                          nil);                 {structure creation parameter}

  ShowWindow(hwndSecond, CmdShow);
  UpdateWindow(hwndSecond);
end; {frmSecondShow}

end.
