unit Sort;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, VbToOp, ExtCtrls;

type
  TfrmSort = class(TForm)
    lstSample: TListBox;
    Label1: TLabel;
    Button1: TButton;
    txtCounter: TEdit;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    txtFind: TEdit;
    lblSequenziale: TLabel;
    lblBinaria: TLabel;
    lblStandard: TLabel;
    chkSorted: TCheckBox;
    StatusBar: TPanel;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure chkSortedClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmSort: TfrmSort;

implementation

{$R *.DFM}

procedure TfrmSort.Button1Click(Sender: TObject);
var I,
    Temp: Integer;
begin
  Screen.Cursor := crHourglass;
  Randomize;
  lstSample.Items.Clear;
  lstSample.Items.BeginUpdate;
  Temp:= STRtoINT(txtCounter.Text);
  For I:= 1 To Temp DO
  Begin
    lstSample.Items.Add(INTtoSTR(Random(Temp)));
  End;
  lstSample.Items.EndUpdate;

  Screen.Cursor := crDefault;
end;

procedure TfrmSort.Button2Click(Sender: TObject);
var I,
    Start,
    Finish: Integer;
    iToFind: String;
begin
  Screen.Cursor := crHourglass;

  start:= GetTickCount;

  iToFind := txtFind.Text;
  For I:= 0 To lstSample.Items.Count-1 DO
    If lstSample.Items[I] = iToFind Then
    Begin
      StatusBar.Caption := txtFind.Text + ' Finded (sequenziale)';
      Break;
    End;

  Finish:= GetTickCount;

  Screen.Cursor := crDefault;
  lblSequenziale.Caption:= INTtoSTR(Finish - start) + ' ticks';
end;

procedure TfrmSort.Button3Click(Sender: TObject);
var Start,
    Finish: Integer;
    iToFind: String;
function FastScan(Matrice: TStringList; sDaTrovare: String): String;
  var Basso,
      Alto,
      Medio  : Integer;
      S      : String;
  begin
    {Inizio di ricerca di tipo binaria, questo tipo di ricerca  caratterizzato
    dal fatto che ha una velocit notevolmente superiore sulla scansione
    di matrice, la vecchia procedura sopra proposta richiede 1000 tentativi per
    scansionare una matrice di 1000 elementi, questa ne richiede solamente
    Log(1000) / Log(2) cio circa 10, la crescita di velocit  inoltre esponen-
    ziale!}
      //Parte da zero
      Basso:= 0;
      Medio:= 0; //Just to stop compiler warnings
      //Arriva al massimo della matrice
      Alto:= Matrice.Count-1;
      sDaTrovare:= AnsiUpperCase(sDaTrovare); //PassaMaiuscola
      //Finch Alto  >= di basso scansiona la matrice
      While Alto >= Basso DO
      begin
        //Medio  la met esatta della matrice
        Medio:= Trunc((Alto+Basso) div 2);
        //Prende il valore della matrice nella met
        S:= AnsiUpperCase(Matrice[Medio]);
        //Se la stringa digitata  maggiore della matrice
        if sDaTrovare > VBLeft(S, Length(sDaTrovare)) then begin
          //Fissa limite inferiore
          Basso:= Medio + 1;
        End Else begin
          //Se la stringa digitata  minore della matrice
          If sDaTrovare < S then begin
            //Fissa limite superiore
            Alto:= Medio - 1;
          End Else begin
            //La stringa  stata trovata, esce dalla procedura!
            Alto:= -1;
          End;
        End;
      end;
    {Fine scansione}

    If Alto = -1 Then begin
      Result:= Matrice[Medio];
    End Else Begin
      Result:= '';
    end;
  end;
begin
  Start := IDNO;

  If chkSorted.Checked = false Then Begin
    Start:= Application.MessageBox(PChar('Ordinamenti'), PChar('Lista non ordinata, impossibile eseguire' +
                     ' FastScan' + #10 + #13 + 'Ordinara la lista ora?'), MB_YESNO);
    If Start = IDNO Then
      Exit;
  End;

  Screen.Cursor := crHourglass;

  If Start = IDYES Then begin
    start:= GetTickCount;
    lstSample.Items.BeginUpdate;
    chkSorted.Checked := not chkSorted.Checked;
    lstSample.Items.EndUpdate;
  end Else Begin
    start:= GetTickCount;
  End;

  iToFind:= FastScan(TStringList(lstSample.Items), txtFind.Text);
  If iToFind = '' Then
    StatusBar.Caption := 'Non trovato'
  Else
    StatusBar.Caption := iToFind + ' Finded (binaria)';

  Finish:= GetTickCount;

  Screen.Cursor := crDefault;
  lblBinaria.Caption:= INTtoSTR(Finish - start) + ' ticks';

end;

procedure TfrmSort.Button4Click(Sender: TObject);
var I,
    Start,
    Finish: Integer;
    iToFind: String;
begin
  Screen.Cursor := crHourglass;

  start:= GetTickCount;

  iToFind := txtFind.Text;

  I:= lstSample.Items.IndexOf(iToFind);
  If I <> -1 Then
    StatusBar.Caption := txtFind.Text + ' Finded (standard)'
  Else
    StatusBar.Caption := 'Non trovato';

  Finish:= GetTickCount;

  Screen.Cursor := crDefault;
  lblStandard.Caption:= INTtoSTR(Finish - start) + ' ticks';
end;

procedure TfrmSort.chkSortedClick(Sender: TObject);
begin
  Screen.Cursor := crHourglass;
  lstSample.Sorted := not lstSample.Sorted;
  Screen.Cursor := crDefault;
end;

end.
