unit wave;

interface

uses
  Windows,
  Messages,
  SysUtils,
  Classes,
  Graphics,
  Controls,
  Forms,
  Dialogs,
  StdCtrls,
  LzExpand,
  MMSystem, ExtCtrls;  //Importante: aggiungere questa unit per funzioni sonore!!!

type
  TfrmResource = class(TForm)
    btnTextFile: TButton;
    Memo: TMemo;
    GroupBox1: TGroupBox;
    btnLoadRes: TButton;
    btnPlayMem: TButton;
    btnPlayFile: TButton;
    btnPlayRes: TButton;
    Image: TImage;
    btnIcon: TButton;
    procedure btnLoadResClick(Sender: TObject);
    procedure btnPlayMemClick(Sender: TObject);
    procedure btnPlayFileClick(Sender: TObject);
    procedure btnPlayResClick(Sender: TObject);
    procedure btnTextFileClick(Sender: TObject);
    procedure btnIconClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmResource: TfrmResource;

implementation

{$R *.DFM}

{$R SUONO.RES} //Linkato il file sonoro!!!!!!!!!!!!!

procedure TfrmResource.btnLoadResClick(Sender: TObject);
var
  h: THandle;
  p: pointer;
begin
  h := FindResource(hInstance, 'HELLO', 'WAVE');
  h := LoadResource(hInstance, h);
  p := LockResource(h);
  sndPlaySound(p, SND_MEMORY or SND_ASYNC);
  UnLockResource(h);
  FreeResource(h);
end;

procedure TfrmResource.btnPlayMemClick(Sender: TObject);
var
  f: file;
  p: pointer;
  fs: integer;
begin
  AssignFile(f, 'hello.wav');
  Reset(f,1);
  fs := FileSize(f);
  GetMem(p, fs);
  BlockRead(f, p^, fs);
  CloseFile(f);
  sndPlaySound(p, SND_MEMORY or SND_ASYNC);
  FreeMem(p, fs);
end;

procedure TfrmResource.btnPlayFileClick(Sender: TObject);
begin
  sndPlaySound('hello.wav', SND_FILENAME or SND_ASYNC);
end;

procedure TfrmResource.btnPlayResClick(Sender: TObject);
begin
  PlaySound('HELLO', hInstance, SND_RESOURCE or SND_ASYNC);
end;

procedure TfrmResource.btnTextFileClick(Sender: TObject);
var
  h: THandle;
  p: Pointer;
  S: String;
begin
  h := FindResource(hInstance, 'BLA', 'BLABLA');
  h := LoadResource(hInstance, h);
  p := LockResource(h);
  S:= PChar(P);

  Memo.Text := S;

  UnLockResource(h);
  FreeResource(h);
end;

procedure TfrmResource.btnIconClick(Sender: TObject);
begin
  Image.Picture.Icon.Handle := LoadIcon(HInstance, 'MAINICON');
end;

end.
